--- old/usr/src/cmd/sendmail/src/sasl.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/sasl.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2001-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: sasl.c,v 8.22 2006/08/15 23:24:57 ca Exp $")
+SM_RCSID("@(#)$Id: sasl.c,v 8.24 2013-11-22 20:51:56 ca Exp $")
 
 #if SASL
 # include <stdlib.h>
@@ -20,13 +20,19 @@
 **  In order to ensure that storage leaks are tracked, and to prevent
 **  conflicts between the sm_heap package and sasl, we tell sasl to
 **  use the following heap allocation functions.  Unfortunately,
-**  the sasl package incorrectly specifies the size of a block
+**  older sasl packages incorrectly specifies the size of a block
 **  using unsigned long: for portability, it should be size_t.
 */
 
-void *sm_sasl_malloc __P((unsigned long));
-static void *sm_sasl_calloc __P((unsigned long, unsigned long));
-static void *sm_sasl_realloc __P((void *, unsigned long));
+# if defined(SASL_VERSION_FULL) && SASL_VERSION_FULL >= 0x02011a
+#  define SM_SASL_SIZE_T	size_t
+# else /* defined(SASL_VERSION_FULL) && SASL_VERSION_FULL >= 0x02011a */
+#  define SM_SASL_SIZE_T	unsigned long
+# endif /* defined(SASL_VERSION_FULL) && SASL_VERSION_FULL >= 0x02011a */
+
+void *sm_sasl_malloc __P((SM_SASL_SIZE_T));
+static void *sm_sasl_calloc __P((SM_SASL_SIZE_T, SM_SASL_SIZE_T));
+static void *sm_sasl_realloc __P((void *, SM_SASL_SIZE_T));
 void sm_sasl_free __P((void *));
 
 /*
@@ -50,7 +56,7 @@
 
 void *
 sm_sasl_malloc(size)
-	unsigned long size;
+	SM_SASL_SIZE_T size;
 {
 	return sm_malloc((size_t) size);
 }
@@ -71,8 +77,8 @@
 
 static void *
 sm_sasl_calloc(nelem, elemsize)
-	unsigned long nelem;
-	unsigned long elemsize;
+	SM_SASL_SIZE_T nelem;
+	SM_SASL_SIZE_T elemsize;
 {
 	size_t size;
 	void *p;
@@ -99,7 +105,7 @@
 static void *
 sm_sasl_realloc(o, size)
 	void *o;
-	unsigned long size;
+	SM_SASL_SIZE_T size;
 {
 	return sm_realloc(o, (size_t) size);
 }
--- old/usr/src/cmd/sendmail/src/savemail.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/savemail.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003, 2006, 2012, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -13,7 +13,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: savemail.c,v 8.314 2009/12/18 17:08:01 ca Exp $")
+SM_RCSID("@(#)$Id: savemail.c,v 8.319 2013-11-22 20:51:56 ca Exp $")
 
 static bool	errbody __P((MCI *, ENVELOPE *, char *));
 static bool	pruneroute __P((char *));
@@ -204,7 +204,7 @@
 				(void) sm_io_fprintf(smioout, SM_TIME_DEFAULT,
 						     "Transcript follows:\r\n");
 				while (sm_io_fgets(e->e_xfp, SM_TIME_DEFAULT,
-						   buf, sizeof(buf)) != NULL &&
+						   buf, sizeof(buf)) >= 0 &&
 				       !sm_io_error(smioout))
 					(void) sm_io_fputs(smioout,
 							   SM_TIME_DEFAULT,
@@ -506,6 +506,7 @@
 	int flags;
 	register ENVELOPE *e;
 {
+	int ret;
 	register ENVELOPE *ee;
 	ENVELOPE *oldcur = CurEnv;
 	ENVELOPE errenvelope;
@@ -703,24 +704,35 @@
 
 	/* actually deliver the error message */
 	sendall(ee, SM_DELIVER);
-
-	/* restore state */
 	(void) dropenvelope(ee, true, false);
-	sm_rpool_free(ee->e_rpool);
-	CurEnv = oldcur;
-	returndepth--;
 
 	/* check for delivery errors */
+	ret = -1;
 	if (ee->e_parent == NULL ||
 	    !bitset(EF_RESPONSE, ee->e_parent->e_flags))
-		return 0;
-	for (q = ee->e_sendqueue; q != NULL; q = q->q_next)
 	{
-		if (QS_IS_ATTEMPTED(q->q_state))
-			return 0;
+		ret = 0;
 	}
-	return -1;
+	else
+	{
+		for (q = ee->e_sendqueue; q != NULL; q = q->q_next)
+		{
+			if (QS_IS_ATTEMPTED(q->q_state))
+			{
+				ret = 0;
+				break;
+			}
+		}
+	}
+
+	/* restore state */
+	sm_rpool_free(ee->e_rpool);
+	CurEnv = oldcur;
+	returndepth--;
+
+	return ret;
 }
+
 /*
 **  ERRBODY -- output the body of an error message.
 **
@@ -854,7 +866,7 @@
 			if (xfile != NULL)
 			{
 				while (sm_io_fgets(xfile, SM_TIME_DEFAULT, buf,
-						   sizeof(buf)) != NULL)
+						   sizeof(buf)) >= 0)
 				{
 					int lbs;
 					bool putok;
@@ -1030,18 +1042,20 @@
 	}
 	else
 	{
+		int blen;
+
 		printheader = true;
 		(void) bfrewind(e->e_parent->e_xfp);
 		if (e->e_xfp != NULL)
 			(void) sm_io_flush(e->e_xfp, SM_TIME_DEFAULT);
-		while (sm_io_fgets(e->e_parent->e_xfp, SM_TIME_DEFAULT, buf,
-				   sizeof(buf)) != NULL)
+		while ((blen = sm_io_fgets(e->e_parent->e_xfp, SM_TIME_DEFAULT,
+					buf, sizeof(buf))) >= 0)
 		{
 			if (printheader && !putline("   ----- Transcript of session follows -----\n",
 						mci))
 				goto writeerr;
 			printheader = false;
-			if (!putline(buf, mci))
+			if (!putxline(buf, blen, mci, PXLF_MAPFROM))
 				goto writeerr;
 		}
 	}
@@ -1162,11 +1176,24 @@
 			/* Original-Recipient: -- passed from on high */
 			if (q->q_orcpt != NULL)
 			{
-				(void) sm_snprintf(buf, sizeof(buf),
-						"Original-Recipient: %.800s",
-						q->q_orcpt);
-				if (!putline(buf, mci))
-					goto writeerr;
+				p = strchr(q->q_orcpt, ';');
+
+				/*
+				**  p == NULL shouldn't happen due to
+				**  check in srvrsmtp.c
+				**  we could log an error in this case.
+				*/
+
+				if (p != NULL)
+				{
+					*p = '\0';
+					(void) sm_snprintf(buf, sizeof(buf),
+						"Original-Recipient: %.100s;%.700s",
+						q->q_orcpt, xuntextify(p + 1));
+					*p = ';';
+					if (!putline(buf, mci))
+						goto writeerr;
+				}
 			}
 
 			/* Figure out actual recipient */
@@ -1668,6 +1695,34 @@
 		else if (c < '!' || c > '~' || c == '=')
 			return false;
 	}
+	return true;
+}
+
+/*
+**  ISATOM -- check if a string is an "atom"
+**
+**	Parameters:
+**		s -- the string to check.
+**
+**	Returns:
+**		true -- iff s is an atom
+*/
+
+bool
+isatom(s)
+	const char *s;
+{
+	int c;
+
+	if (s == NULL || *s == '\0')
+		return false;
+	while ((c = *s++) != '\0')
+	{
+		if (strchr("()<>@,;:\\.[]\"", c) != NULL)
+			return false;
+		if (c < '!' || c > '~')
+			return false;
+	}
 	return true;
 }
 /*
--- old/usr/src/cmd/sendmail/src/sendmail.h	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/sendmail.h	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -52,7 +52,7 @@
 
 #ifdef _DEFINE
 # ifndef lint
-SM_UNUSED(static char SmailId[]) = "@(#)$Id: sendmail.h,v 8.1068 2009/12/18 17:08:01 ca Exp $";
+SM_UNUSED(static char SmailId[]) = "@(#)$Id: sendmail.h,v 8.1104 2013-11-22 20:51:56 ca Exp $";
 # endif /* ! lint */
 #endif /* _DEFINE */
 
@@ -124,7 +124,11 @@
 #if STARTTLS
 #  include <openssl/ssl.h>
 # if !TLS_NO_RSA
-#  define RSA_KEYLENGTH	512
+#  if _FFR_FIPSMODE
+#   define RSA_KEYLENGTH	1024
+#  else /* _FFR_FIPSMODE  */
+#   define RSA_KEYLENGTH	512
+#  endif /* _FFR_FIPSMODE  */
 # endif /* !TLS_NO_RSA */
 #endif /* STARTTLS */
 
@@ -133,10 +137,15 @@
 
 # if SASL == 2 || SASL >= 20000
 #  include <sasl/sasl.h>
+#  include <sasl/saslplug.h>
 #  include <sasl/saslutil.h>
+#  if SASL_VERSION_FULL < 0x020119
+typedef int (*sasl_callback_ft)(void);
+#  endif /* SASL_VERSION_FULL < 0x020119 */
 # else /* SASL == 2 || SASL >= 20000 */
 #  include <sasl.h>
 #  include <saslutil.h>
+typedef int (*sasl_callback_ft)(void);
 # endif /* SASL == 2 || SASL >= 20000 */
 # if defined(SASL_VERSION_MAJOR) && defined(SASL_VERSION_MINOR) && defined(SASL_VERSION_STEP)
 #  define SASL_VERSION (SASL_VERSION_MAJOR * 10000)  + (SASL_VERSION_MINOR * 100) + SASL_VERSION_STEP
@@ -327,8 +336,8 @@
 				 (s) == QS_SENT || \
 				 (s) == QS_DISCARDED)
 #define QS_IS_DEAD(s)		((s) >= QS_DONTSEND)
+#define QS_IS_TEMPFAIL(s)	((s) == QS_QUEUEUP || (s) == QS_RETRY)
 
-
 #define NULLADDR	((ADDRESS *) NULL)
 
 extern ADDRESS	NullAddress;	/* a null (template) address [main.c] */
@@ -474,6 +483,7 @@
 #define M_HOLD		'%'	/* Hold delivery until ETRN/-qI/-qR/-qS */
 #define M_PLUS		'+'	/* Reserved: Used in mc for adding new flags */
 #define M_MINUS		'-'	/* Reserved: Used in mc for removing flags */
+#define M_NOMHHACK	'!'	/* Don't perform HM hack dropping explicit from */
 
 /* functions */
 extern void	initerrmailers __P((void));
@@ -721,9 +731,9 @@
 #if STARTTLS
 #define MCIF_TLS	0x00100000	/* STARTTLS supported */
 #define MCIF_TLSACT	0x00200000	/* STARTTLS active */
-#define MCIF_EXTENS	(MCIF_EXPN | MCIF_SIZE | MCIF_8BITMIME | MCIF_DSN | MCIF_8BITOK | MCIF_AUTH | MCIF_ENHSTAT | MCIF_TLS)
 #else /* STARTTLS */
-#define MCIF_EXTENS	(MCIF_EXPN | MCIF_SIZE | MCIF_8BITMIME | MCIF_DSN | MCIF_8BITOK | MCIF_AUTH | MCIF_ENHSTAT)
+#define MCIF_TLS	0
+#define MCIF_TLSACT	0
 #endif /* STARTTLS */
 #define MCIF_DLVR_BY	0x00400000	/* DELIVERBY */
 #if _FFR_IGNORE_EXT_ON_HELO
@@ -730,8 +740,11 @@
 # define MCIF_HELO	0x00800000	/* we used HELO: ignore extensions */
 #endif /* _FFR_IGNORE_EXT_ON_HELO */
 #define MCIF_INLONGLINE 0x01000000	/* in the middle of a long line */
+#define MCIF_AUTH2	0x02000000	/* got 2 AUTH lines */
 #define MCIF_ONLY_EHLO	0x10000000	/* use only EHLO in smtpinit */
 
+#define MCIF_EXTENS	(MCIF_EXPN | MCIF_SIZE | MCIF_8BITMIME | MCIF_DSN | MCIF_8BITOK | MCIF_AUTH | MCIF_ENHSTAT | MCIF_TLS | MCIF_AUTH2)
+
 /* states */
 #define MCIS_CLOSED	0		/* no traffic on this connection */
 #define MCIS_OPENING	1		/* sending initial protocol */
@@ -749,6 +762,7 @@
 extern void	mci_dump __P((SM_FILE_T *, MCI *, bool));
 extern void	mci_dump_all __P((SM_FILE_T *, bool));
 extern void	mci_flush __P((bool, MCI *));
+extern void	mci_clr_extensions __P((MCI *));
 extern MCI	*mci_get __P((char *, MAILER *));
 extern int	mci_lock_host __P((MCI *));
 extern bool	mci_match __P((char *, MAILER *));
@@ -937,6 +951,8 @@
 #endif /* _FFR_MILTER_ENHSC */
 };
 
+#define PRT_NONNEGL(v)	((v) < 0 ? LONG_MAX : (v))
+
 /* values for e_flags */
 #define EF_OLDSTYLE	0x00000001L	/* use spaces (not commas) in hdrs */
 #define EF_INQUEUE	0x00000002L	/* this message is fully queued */
@@ -1167,6 +1183,33 @@
 
 typedef struct hostsig_t HOSTSIG_T;
 
+/*
+**  The standard udp packet size PACKETSZ (512) is not sufficient for some
+**  nameserver answers containing very many resource records. The resolver
+**  may switch to tcp and retry if it detects udp packet overflow.
+**  Also note that the resolver routines res_query and res_search return
+**  the size of the *un*truncated answer in case the supplied answer buffer
+**  it not big enough to accommodate the entire answer.
+*/
+
+# ifndef MAXPACKET
+#  define MAXPACKET 8192	/* max packet size used internally by BIND */
+# endif /* ! MAXPACKET */
+
+/*
+**  The resolver functions res_{send,query,querydomain} expect the
+**  answer buffer to be aligned, but some versions of gcc4 reverse
+**  25 years of history and no longer align char buffers on the
+**  stack, resulting in crashes on strict-alignment platforms.  Use
+**  this union when putting the buffer on the stack to force the
+**  alignment, then cast to (HEADER *) or (unsigned char *) as needed.
+*/
+typedef union
+{
+	HEADER		qb1;
+	unsigned char	qb2[MAXPACKET];
+} querybuf;
+
 /* functions */
 extern bool	getcanonname __P((char *, int, bool, int *));
 extern int	getmxrr __P((char *, char **, unsigned short *, bool, int *, bool, int *));
@@ -1246,11 +1289,15 @@
 #define MF_OPENBOGUS	0x00800000	/* open failed, don't call map_close */
 #define MF_CLOSING	0x01000000	/* map is being closed */
 
-#define DYNOPENMAP(map) if (!bitset(MF_OPEN, (map)->map_mflags)) \
-	{	\
-		if (!openmap(map))	\
-			return NULL;	\
-	}
+#define DYNOPENMAP(map) \
+	do		\
+	{		\
+		if (!bitset(MF_OPEN, (map)->map_mflags)) \
+		{	\
+			if (!openmap(map))	\
+				return NULL;	\
+		}	\
+	} while (0)
 
 
 /* indices for map_actions */
@@ -1446,7 +1493,6 @@
 	union
 	{
 		BITMAP256	sv_class;	/* bit-map of word classes */
-		ADDRESS		*sv_addr;	/* pointer to address header */
 		MAILER		*sv_mailer;	/* pointer to mailer */
 		char		*sv_alias;	/* alias */
 		MAPCLASS	sv_mapclass;	/* mapping function class */
@@ -1476,7 +1522,7 @@
 /* symbol types */
 #define ST_UNDEF	0	/* undefined type */
 #define ST_CLASS	1	/* class map */
-#define ST_ADDRESS	2	/* an address in parsed format */
+/* #define ST_unused	2	UNUSED */
 #define ST_MAILER	3	/* a mailer header */
 #define ST_ALIAS	4	/* an alias */
 #define ST_MAPCLASS	5	/* mapping function class */
@@ -1503,7 +1549,6 @@
 #define ST_MCI		17	/* mailer connection info (offset) */
 
 #define s_class		s_value.sv_class
-#define s_address	s_value.sv_addr
 #define s_mailer	s_value.sv_mailer
 #define s_alias		s_value.sv_alias
 #define s_mci		s_value.sv_mci
@@ -1569,8 +1614,19 @@
 
 #if _FFR_LOCAL_DAEMON
 EXTERN bool	LocalDaemon;
+# if NETINET6
+EXTERN bool	V6LoopbackAddrFound;	/* found an IPv6 loopback address */
+#  define SETV6LOOPBACKADDRFOUND(sa)	\
+	do	\
+	{	\
+		if (isloopback(sa))	\
+			V6LoopbackAddrFound = true;	\
+	} while (0)
+# endif /* NETINET6 */
 #else /* _FFR_LOCAL_DAEMON */
 # define LocalDaemon	false
+# define V6LoopbackAddrFound	false
+# define SETV6LOOPBACKADDRFOUND(sa)
 #endif /* _FFR_LOCAL_DAEMON */
 
 /* Note: see also include/sendmail/pathnames.h: GET_CLIENT_CF */
@@ -1585,6 +1641,7 @@
 #define SM_DEFER	'd'		/* defer map lookups as well as queue */
 #define SM_VERIFY	'v'		/* verify only (used internally) */
 #define DM_NOTSET	(-1)	/* DeliveryMode (per daemon) option not set */
+# define SM_IS_INTERACTIVE(m)	((m) == SM_DELIVER)
 
 #define WILL_BE_QUEUED(m)	((m) == SM_QUEUE || (m) == SM_DEFER)
 
@@ -1733,6 +1790,8 @@
 	char		*mf_conn;	/* connection info */
 	int		mf_sock;	/* connected socket */
 	char		mf_state;	/* state of filter */
+	char		mf_lflags;	/* "local" flags */
+	int		mf_idx;		/* milter number (index) */
 	time_t		mf_timeout[SMFTO_NUM_TO]; /* timeouts */
 #if _FFR_MILTER_CHECK
 	/* for testing only */
@@ -1742,6 +1801,9 @@
 #endif /* _FFR_MILTER_CHECK */
 };
 
+#define MI_LFL_NONE	0x00000000
+#define MI_LFLAGS_SYM(st) (1 << (st))	/* has its own symlist for stage st */
+
 struct milters
 {
 	mi_int32	mis_flags;	/* filter flags */
@@ -1785,7 +1847,7 @@
 #define VENDOR_SUN	2	/* Sun-native configuration file */
 #define VENDOR_HP	3	/* Hewlett-Packard specific config syntax */
 #define VENDOR_IBM	4	/* IBM specific config syntax */
-#define VENDOR_SENDMAIL	5	/* Sendmail, Inc. specific config syntax */
+#define VENDOR_SENDMAIL	5	/* Proofpoint, Inc. specific config syntax */
 #define VENDOR_DEC	6	/* Compaq, DEC, Digital */
 
 /* prototypes for vendor-specific hook routines */
@@ -1884,7 +1946,7 @@
 #define TLS_AUTH_FAIL	(-1)
 
 /* functions */
-extern bool	init_tls_library __P((void));
+extern bool	init_tls_library __P((bool _fipsmode));
 extern bool	inittls __P((SSL_CTX **, unsigned long, long, bool, char *, char *, char *, char *, char *));
 extern bool	initclttls __P((bool));
 extern void	setclttls __P((bool));
@@ -1891,7 +1953,7 @@
 extern bool	initsrvtls __P((bool));
 extern int	tls_get_info __P((SSL *, bool, char *, MACROS_T *, bool));
 extern int	endtls __P((SSL *, char *));
-extern void	tlslogerr __P((const char *));
+extern void	tlslogerr __P((int, const char *));
 
 
 EXTERN char	*CACertPath;	/* path to CA certificates (dir. with hashes) */
@@ -2100,7 +2162,11 @@
 */
 
 /* macros for debugging flags */
-#define tTd(flag, level)	(tTdvect[flag] >= (unsigned char)level)
+#if NOT_SENDMAIL
+# define tTd(flag, level)	(tTdvect[flag] >= (unsigned char)level)
+#else
+# define tTd(flag, level)	(tTdvect[flag] >= (unsigned char)level && !IntSig)
+#endif
 #define tTdlevel(flag)		(tTdvect[flag])
 
 /* variables */
@@ -2123,10 +2189,12 @@
 */
 
 /* set exit status */
-#define setstat(s)	{ \
-				if (ExitStat == EX_OK || ExitStat == EX_TEMPFAIL) \
-					ExitStat = s; \
-			}
+#define setstat(s)	\
+	do		\
+	{		\
+		if (ExitStat == EX_OK || ExitStat == EX_TEMPFAIL) \
+			ExitStat = s; \
+	} while (0)
 
 
 #define STRUCTCOPY(s, d)	d = s
@@ -2133,12 +2201,14 @@
 
 /* free a pointer if it isn't NULL and set it to NULL */
 #define SM_FREE_CLR(p)	\
-			if ((p) != NULL) \
-			{ \
-				sm_free(p); \
-				(p) = NULL; \
-			} \
-			else
+	do		\
+	{		\
+		if ((p) != NULL) \
+		{ \
+			sm_free(p); \
+			(p) = NULL; \
+		} \
+	} while (0)
 
 /*
 **  Update a permanent string variable with a new value.
@@ -2181,10 +2251,32 @@
 
 # define CHECK_RESTART _CHECK_RESTART
 
+#define CHK_CUR_RUNNERS(fct, idx, count)	\
+	do	\
+	{	\
+		if (CurRunners < 0)	\
+		{	\
+			if (LogLevel > 3)	\
+				sm_syslog(LOG_ERR, NOQID,	\
+					"%s: CurRunners=%d, i=%d, count=%d, status=should not happen",	\
+					fct, CurRunners, idx, count);	\
+			CurRunners = 0;	\
+		}	\
+	} while (0)
+
 /* reply types (text in SmtpMsgBuffer) */
 #define XS_DEFAULT	0
 #define XS_STARTTLS	1
 #define XS_AUTH		2
+#define XS_GREET	3
+#define XS_EHLO		4
+#define XS_MAIL		5
+#define XS_RCPT		6
+#define XS_DATA		7
+#define XS_EOM		8
+#define XS_DATA2	9
+#define XS_RCPT2	10
+#define XS_QUIT		15
 
 /*
 **  Global variables.
@@ -2209,6 +2301,7 @@
 EXTERN bool	DontPruneRoutes;	/* don't prune source routes */
 EXTERN bool	ForkQueueRuns;	/* fork for each job when running the queue */
 EXTERN bool	FromFlag;	/* if set, "From" person is explicit */
+EXTERN bool	FipsMode;
 EXTERN bool	GrabTo;		/* if set, get recipients from msg */
 EXTERN bool	EightBitAddrOK;	/* we'll let 8-bit addresses through */
 EXTERN bool	HasEightBits;	/* has at least one eight bit input byte */
@@ -2223,6 +2316,9 @@
 EXTERN bool	NoConnect;	/* don't connect to non-local mailers */
 EXTERN bool	OnlyOneError;	/*  .... or only want to give one SMTP reply */
 EXTERN bool	QuickAbort;	/*  .... but only if we want a quick abort */
+#if _FFR_REJECT_NUL_BYTE
+EXTERN bool	RejectNUL;	/* reject NUL input byte? */
+#endif /* _FFR_REJECT_NUL_BYTE */
 #if REQUIRES_DIR_FSYNC
 EXTERN bool	RequiresDirfsync;	/* requires fsync() for directory */
 #endif /* REQUIRES_DIR_FSYNC */
@@ -2363,6 +2459,7 @@
 EXTERN char	*SafeFileEnv;	/* chroot location for file delivery */
 EXTERN char	*ServiceSwitchFile;	/* backup service switch */
 EXTERN char	*volatile ShutdownRequest;/* a sendmail shutdown has been requested */
+EXTERN bool	volatile IntSig;
 EXTERN char	*SmtpGreeting;	/* SMTP greeting message (old $e macro) */
 EXTERN char	*SmtpPhase;	/* current phase in SMTP processing */
 EXTERN char	SmtpError[MAXLINE];	/* save failure error messages */
@@ -2390,6 +2487,9 @@
 
 
 EXTERN int ConnectionRateWindowSize;
+#if STARTTLS && USE_OPENSSL_ENGINE
+EXTERN bool	SSLEngineInitialized;
+#endif /* STARTTLS && USE_OPENSSL_ENGINE */
 
 /*
 **  Declarations of useful functions
@@ -2442,6 +2542,8 @@
 extern void	smtprset __P((MAILER *, MCI *, ENVELOPE *));
 
 #define REPLYTYPE(r)	((r) / 100)		/* first digit of reply code */
+#define REPLYCLASS(r)	(((r) / 10) % 10)	/* second digit of reply code */
+#define REPLYMINOR(r)	((r) % 10)	/* last digit of reply code */
 #define ISSMTPCODE(c)	(isascii(c[0]) && isdigit(c[0]) && \
 		    isascii(c[1]) && isdigit(c[1]) && \
 		    isascii(c[2]) && isdigit(c[2]))
@@ -2562,6 +2664,7 @@
 extern void	initsetproctitle __P((int, char **, char **));
 extern void	init_vendor_macros __P((ENVELOPE *));
 extern SIGFUNC_DECL	intsig __P((int));
+extern bool	isatom __P((const char *));
 extern bool	isloopback __P((SOCKADDR sa));
 extern void	load_if_names __P((void));
 extern bool	lockfile __P((int, char *, char *, int));
--- old/usr/src/cmd/sendmail/src/sfsasl.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/sfsasl.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2006, 2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2006, 2008 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -9,7 +9,7 @@
  */
 
 #include <sm/gen.h>
-SM_RCSID("@(#)$Id: sfsasl.c,v 8.118 2008/07/22 15:12:48 ca Exp $")
+SM_RCSID("@(#)$Id: sfsasl.c,v 8.121 2013-11-22 20:51:56 ca Exp $")
 #include <stdlib.h>
 #include <sendmail.h>
 #include <sm/time.h>
@@ -628,7 +628,7 @@
 				  "STARTTLS=%s, error: fd %d/%d too large",
 				  where, rfd, wfd);
 		if (LogLevel > 8)
-			tlslogerr(where);
+			tlslogerr(LOG_WARNING, where);
 		}
 		errno = EINVAL;
 	}
@@ -635,6 +635,7 @@
 	else if (err == SSL_ERROR_WANT_READ)
 	{
 		fd_set ssl_maskr, ssl_maskx;
+		int save_errno = errno;
 
 		FD_ZERO(&ssl_maskr);
 		FD_SET(rfd, &ssl_maskr);
@@ -647,10 +648,12 @@
 		} while (ret < 0 && errno == EINTR);
 		if (ret < 0 && errno > 0)
 			ret = -errno;
+		errno = save_errno;
 	}
 	else if (err == SSL_ERROR_WANT_WRITE)
 	{
 		fd_set ssl_maskw, ssl_maskx;
+		int save_errno = errno;
 
 		FD_ZERO(&ssl_maskw);
 		FD_SET(wfd, &ssl_maskw);
@@ -663,6 +666,7 @@
 		} while (ret < 0 && errno == EINTR);
 		if (ret < 0 && errno > 0)
 			ret = -errno;
+		errno = save_errno;
 	}
 	return ret;
 }
@@ -770,9 +774,18 @@
 			break;
 #endif /* DEAL_WITH_ERROR_SSL */
 		err = "generic SSL error";
+
 		if (LogLevel > 9)
-			tlslogerr("read");
+		{
+			int pri;
 
+			if (errno == EAGAIN && try > 0)
+				pri = LOG_DEBUG;
+			else
+				pri = LOG_WARNING;
+			tlslogerr(pri, "read");
+		}
+
 #if DEAL_WITH_ERROR_SSL
 		/* avoid repeated calls? */
 		if (r == 0)
@@ -792,11 +805,19 @@
 					  "STARTTLS: read error=timeout");
 		}
 		else if (LogLevel > 8)
-			sm_syslog(LOG_WARNING, NOQID,
+		{
+			int pri;
+
+			if (save_errno == EAGAIN && try > 0)
+				pri = LOG_DEBUG;
+			else
+				pri = LOG_WARNING;
+			sm_syslog(pri, NOQID,
 				  "STARTTLS: read error=%s (%d), errno=%d, get_error=%s, retry=%d, ssl_err=%d",
 				  err, r, errno,
 				  ERR_error_string(ERR_get_error(), NULL), try,
 				  ssl_err);
+		}
 		else if (LogLevel > 7)
 			sm_syslog(LOG_WARNING, NOQID,
 				  "STARTTLS: read error=%s (%d), retry=%d, ssl_err=%d",
@@ -878,7 +899,7 @@
 		ERR_GET_REASON(ERR_peek_error()));
 */
 		if (LogLevel > 9)
-			tlslogerr("write");
+			tlslogerr(LOG_WARNING, "write");
 
 #if DEAL_WITH_ERROR_SSL
 		/* avoid repeated calls? */
--- old/usr/src/cmd/sendmail/src/sfsasl.h	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/sfsasl.h	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999, 2000, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999, 2000, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: sfsasl.h,v 8.20 2006/03/27 21:31:00 ca Exp $"
+ *	$Id: sfsasl.h,v 8.21 2013-11-22 20:51:56 ca Exp $"
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef SFSASL_H
 # define SFSASL_H
 
--- old/usr/src/cmd/sendmail/src/sm_resolve.c	Sat Feb  6 15:36:47 2016
+++ new/usr/src/cmd/sendmail/src/sm_resolve.c	Sat Feb  6 15:36:47 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2004 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2004, 2010 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -41,14 +41,16 @@
  * SUCH DAMAGE.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 #if DNSMAP
 # if NAMED_BIND
+#  if NETINET
+#   include <netinet/in_systm.h>
+#   include <netinet/ip.h>
+#  endif /* NETINET */
 #  include "sm_resolve.h"
 
-SM_RCSID("$Id: sm_resolve.c,v 8.36 2008/02/11 23:04:16 ca Exp $")
+SM_RCSID("$Id: sm_resolve.c,v 8.40 2013-11-22 20:51:56 ca Exp $")
 
 static struct stot
 {
@@ -396,8 +398,14 @@
 	time_t save_retrans = 0;
 	int save_retry = 0;
 	DNS_REPLY_T *r = NULL;
-	unsigned char reply[1024];
+	querybuf reply_buf;
+	unsigned char *reply;
 
+#define SMRBSIZE sizeof(reply_buf)
+#ifndef IP_MAXPACKET
+# define IP_MAXPACKET	65535
+#endif
+
 	if (tTd(8, 16))
 	{
 		old_options = _res.options;
@@ -417,7 +425,31 @@
 	}
 	errno = 0;
 	SM_SET_H_ERRNO(0);
-	len = res_search(domain, rr_class, rr_type, reply, sizeof(reply));
+	reply = (unsigned char *)&reply_buf;
+	len = res_search(domain, rr_class, rr_type, reply, SMRBSIZE);
+	if (len >= SMRBSIZE)
+	{
+		if (len >= IP_MAXPACKET)
+		{
+			if (tTd(8, 4))
+				sm_dprintf("dns_lookup: domain=%s, length=%d, default_size=%d, max=%d, status=response too long\n",
+					   domain, len, (int) SMRBSIZE,
+					   IP_MAXPACKET);
+		}
+		else
+		{
+			if (tTd(8, 6))
+				sm_dprintf("dns_lookup: domain=%s, length=%d, default_size=%d, max=%d, status=response longer than default size, resizing\n",
+					   domain, len, (int) SMRBSIZE,
+					   IP_MAXPACKET);
+			reply = (unsigned char *)sm_malloc(IP_MAXPACKET);
+			if (reply == NULL)
+				SM_SET_H_ERRNO(TRY_AGAIN);
+			else
+				len = res_search(domain, rr_class, rr_type,
+						 reply, IP_MAXPACKET);
+		}
+	}
 	if (tTd(8, 16))
 	{
 		_res.options = old_options;
@@ -424,8 +456,13 @@
 		sm_dprintf("dns_lookup(%s, %d, %s) --> %d\n",
 			   domain, rr_class, dns_type_to_string(rr_type), len);
 	}
-	if (len >= 0)
+	if (len >= 0 && len < IP_MAXPACKET && reply != NULL)
 		r = parse_dns_reply(reply, len);
+	if (reply != (unsigned char *)&reply_buf && reply != NULL)
+	{
+		sm_free(reply);
+		reply = NULL;
+	}
 	if (retrans > 0)
 		_res.retrans = save_retrans;
 	if (retry > 0)
--- old/usr/src/cmd/sendmail/src/sm_resolve.h	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/sm_resolve.h	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -8,8 +8,6 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
  * Copyright (c) 1995, 1996, 1997, 1998, 1999 Kungliga Tekniska Högskolan
  * (Royal Institute of Technology, Stockholm, Sweden).
@@ -43,7 +41,7 @@
  * SUCH DAMAGE.
  */
 
-/* $Id: sm_resolve.h,v 8.8 2001/09/01 00:06:02 gshapiro Exp $ */
+/* $Id: sm_resolve.h,v 8.9 2013-11-22 20:51:56 ca Exp $ */
 
 #if DNSMAP
 # ifndef __ROKEN_RESOLVE_H__
